import React from 'react';
const URLleaderboard = "http://localhost:8080/racetimer_endpoints-1.0/api/timers/leaderboard";
const URLPlayer = "http://localhost:8080/racetimer_endpoints-1.0/api/timers/player/";
const URLPlayerMaps = "http://localhost:8080/racetimer_endpoints-1.0/api/timers/player/maps/";
const URLMaps = "http://localhost:8080/racetimer_endpoints-1.0/api/timers/map/";
const URLAllMaps = "http://localhost:8080/racetimer_endpoints-1.0/api/timers/allmaps";

function handleHttpErrors(res) {
  if (!res.ok) {
    return Promise.reject({ status: res.status, fullError: res.json() });
  }
  return res.json();
}

class DataFacade extends React.Component {
  constructor(props) {
    super(props);
    this.state = {

    };
  }

  

  getLeaderBoardFromCache = async (incrementer) => {
    const CachedTime = JSON.parse(localStorage.getItem("leaderboardTimer"));
    const timeExpired = CachedTime ? Date.now() - CachedTime : 0;
    //30 mins
    if (!CachedTime || timeExpired > 30 * 60000) {
      localStorage.setItem("leaderboardTimer", JSON.stringify(Date.now()));
      localStorage.removeItem("leaderboard");
      incrementer = 0;
    }
    var leaderBoardData = localStorage.getItem("leaderboard");
    if (incrementer === 0 && leaderBoardData) {
      const cachedLeaderBoard = JSON.parse(leaderBoardData);
      return cachedLeaderBoard;
    } else {
      const players = await fetch(URLleaderboard + "/" + incrementer).then(handleHttpErrors);
      if (leaderBoardData !== null) {
        const cachedLeaderBoard = JSON.parse(leaderBoardData);
        players.map(e => (
          cachedLeaderBoard.push(e)
        ))
        localStorage.setItem("leaderboard", JSON.stringify(cachedLeaderBoard));
        return cachedLeaderBoard;
      } else {
        localStorage.setItem("leaderboard", JSON.stringify(players));
        return players;
      }
    }
  };

  getAllMapsFromCache = async () => {
    const CachedTime = JSON.parse(localStorage.getItem("allmapsTimer"));
    const timeExpired = CachedTime ? Date.now() - CachedTime : 0;
    //30 mins
    if (!CachedTime || timeExpired > 30 * 60000) {
      localStorage.setItem("allmapsTimer", JSON.stringify(Date.now()));
      localStorage.removeItem("allmaps");
    }
    var allMapsData = localStorage.getItem("allmaps");
    if (allMapsData) {
      const cachedAllMaps = JSON.parse(allMapsData);
      return cachedAllMaps;
    } else {
      const allMaps = await fetch(URLAllMaps).then(handleHttpErrors);
      localStorage.setItem("allmaps", JSON.stringify(allMaps));
      return allMaps;
    }
  };

  getPlayerFromCache = async (steamID) => {
    const CachedTime = JSON.parse(localStorage.getItem("initialCachedplayers" + steamID));
    const timeExpired = CachedTime ? Date.now() - CachedTime : 0;
    //30 mins
    if (!CachedTime || timeExpired > 30 * 60000) {
      localStorage.setItem("initialCachedplayers" + steamID, JSON.stringify(Date.now()));
      localStorage.removeItem("player/" + steamID)
    }
    var storageString = "player/" + steamID;
    const playerData = localStorage.getItem(storageString);
    if (playerData) {
      const player = JSON.parse(playerData);
      return player;
    } else {
      const player = await fetch(URLPlayer + steamID).then(handleHttpErrors);
      localStorage.setItem(storageString, JSON.stringify(player));
      return player;
    }
  }

  getPlayerTimesFromCache = async (steamID) => {
    const CachedTime = JSON.parse(localStorage.getItem("initialCachedplayersTimes" + steamID));
    const timeExpired = CachedTime ? Date.now() - CachedTime : 0;
    //30 mins
    if (!CachedTime || timeExpired > 30 * 60000) {
      localStorage.setItem("initialCachedplayersTimes" + steamID, JSON.stringify(Date.now()));
      localStorage.removeItem("playertimes/" + steamID)
    }
    var storageString = "playertimes/" + steamID;
    var playerTimesData = localStorage.getItem(storageString);
    if (playerTimesData) {
      const cachedPlayerTimes = JSON.parse(playerTimesData)
      return cachedPlayerTimes;
    } else {
      const playertimes = await fetch(URLPlayerMaps + steamID).then(handleHttpErrors);
      localStorage.setItem(storageString, JSON.stringify(playertimes));
      return playertimes;
    }
  }

  getMapTimesFromCache = async (mapname, stage) => {
    const CachedTime = JSON.parse(localStorage.getItem("maptimescached" + mapname + stage));
    const timeExpired = CachedTime ? Date.now() - CachedTime : 0;
    //30 mins
    if (!CachedTime || timeExpired > 30 * 60000) {
      localStorage.setItem("maptimescached" + mapname + stage, JSON.stringify(Date.now()));
      localStorage.removeItem("map/" + mapname + stage);
    }
    var mapTimesData = localStorage.getItem("map/" + mapname + stage);
    if (mapTimesData) {
      const cachedMapTimes = JSON.parse(mapTimesData);
      return cachedMapTimes;
    } else {
      const mapTimes = await fetch(URLMaps + mapname + "/" + stage).then(handleHttpErrors);
      localStorage.setItem("map/" + mapname + stage, JSON.stringify(mapTimes));
      return mapTimes;
    }
  }

}

export default new DataFacade();