import React from 'react';
import Facade from '../Datafacade/datafacade';
import { NavLink } from 'react-router-dom';

class Maps extends React.Component {

    constructor(props) {
        super(props)
        this.state = {
            mapTimes: [],
            mapName: '',
        };
    }

    componentWillMount = async () => {
        const mapname = this.props.match.params.mapname;
        const stage = this.props.match.params.stage;
        const mapTimes = await Facade.getMapTimesFromCache(mapname, stage);
        this.setState({ mapTimes });
        this.setState({ mapName: mapname })
    };

    render() {
        return (
            <React.Fragment>
                <div className="alert alert-primary" >
                    <NavLink to={'/leaderboard/'}>
                        <h3> <strong className="col-lg-1 col-centered" /> leaderboard<br /> </h3>
                    </NavLink>
                    <NavLink to={'/mapboard/'}>
                        <h3> <strong className="col-lg-1 col-centered" /> MapBoard<br /> </h3>
                    </NavLink>
                </div>
                <div className="container mm" style={{ marginTop: "85px" }}>
                    <div style={{
                        position: 'absolute', left: '50%', top: '30%'
                    }}>

                        <br />
                        <br />
                        <div>
                            <strong className="col-lg-1 col-centered" />{this.state.mapName}<br />
                            <br />
                            <br />
                            {this.state.mapTimes.map(e => (
                                <div className="item" key={e.steamID}>
                                    <div className="box_grid">
                                        <NavLink to={'/player/' + e.steamID}>
                                            <strong className="col-lg-1 col-centered" /> SteamID: {e.steamID}<br />
                                            <strong className="col-lg-1 col-centered" /> Name: {e.name}<br />
                                            <img src={e.avatar} alt=""/> <br />
                                        </NavLink>
                                        <strong className="col-lg-1 col-centered" /> Position: {e.position}<br />
                                        <strong className="col-lg-1 col-centered" /> Mappoints: {e.mapPoint}<br />
                                        <strong className="col-lg-1 col-centered" /> Time: 0{e.mapTimeMinutes}:{e.mapTimeSeconds}<br />
                                        <br />
                                        <br />
                                    </div>
                                </div>
                            ))}

                        </div>
                    </div>
                </div>
            </React.Fragment>
        )
    }
}


export default Maps;